API reference

Projects

Endpoints and input schemas from the console's API registry.

GET /api/projects

List projects

Needs the projects.read permission on the API key's role.

No request-body schema is supplied for this operation in the registry.

Documented responses

  • 200 — OK
  • 400 — The body is not valid; `error` says why
  • 401 — No valid API key
  • 403 — The key's role lacks the permission, or the module is off

POST /api/projects

Create a project

Needs the projects.write permission on the API key's role.

JSON request schema
{
  "type": "object",
  "properties": {
    "clientId": {
      "type": "string",
      "minLength": 1
    },
    "name": {
      "type": "string",
      "minLength": 1
    },
    "description": {
      "type": "string"
    },
    "status": {
      "default": "ACTIVE",
      "type": "string",
      "enum": [
        "ACTIVE",
        "COMPLETED",
        "ON_HOLD",
        "CANCELLED"
      ]
    },
    "startDate": {
      "type": [
        "string",
        "null"
      ]
    },
    "endDate": {
      "type": [
        "string",
        "null"
      ]
    },
    "memberIds": {
      "type": "array",
      "items": {
        "type": "string"
      }
    },
    "stageId": {
      "type": "string",
      "minLength": 1
    },
    "leaderUserId": {
      "anyOf": [
        {
          "type": "string",
          "minLength": 1
        },
        {
          "type": "null"
        }
      ]
    },
    "dueDate": {
      "type": [
        "string",
        "null"
      ]
    },
    "value": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0
        },
        {
          "type": "null"
        }
      ]
    },
    "budgetVendor": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0,
          "maximum": 999999999999.99
        },
        {
          "type": "null"
        }
      ]
    },
    "budgetClaims": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0,
          "maximum": 999999999999.99
        },
        {
          "type": "null"
        }
      ]
    },
    "budgetHours": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0,
          "maximum": 99999999.99
        },
        {
          "type": "null"
        }
      ]
    }
  },
  "required": [
    "clientId",
    "name"
  ]
}

Documented responses

  • 200 — OK
  • 201 — Created
  • 400 — The body is not valid; `error` says why
  • 401 — No valid API key
  • 403 — The key's role lacks the permission, or the module is off

GET /api/projects/{id}

Read a project

Needs the projects.read permission on the API key's role.

Path parameters

  • id — required path parameter

No request-body schema is supplied for this operation in the registry.

Documented responses

  • 200 — OK
  • 400 — The body is not valid; `error` says why
  • 401 — No valid API key
  • 403 — The key's role lacks the permission, or the module is off
  • 404 — Not found in this company

PATCH /api/projects/{id}

Change a project

Needs the projects.write permission on the API key's role.

Path parameters

  • id — required path parameter
JSON request schema
{
  "type": "object",
  "properties": {
    "clientId": {
      "type": "string",
      "minLength": 1
    },
    "name": {
      "type": "string",
      "minLength": 1
    },
    "description": {
      "type": "string"
    },
    "status": {
      "type": "string",
      "enum": [
        "ACTIVE",
        "COMPLETED",
        "ON_HOLD",
        "CANCELLED"
      ]
    },
    "startDate": {
      "type": [
        "string",
        "null"
      ]
    },
    "endDate": {
      "type": [
        "string",
        "null"
      ]
    },
    "memberIds": {
      "type": "array",
      "items": {
        "type": "string"
      }
    },
    "stageId": {
      "type": "string",
      "minLength": 1
    },
    "leaderUserId": {
      "anyOf": [
        {
          "type": "string",
          "minLength": 1
        },
        {
          "type": "null"
        }
      ]
    },
    "dueDate": {
      "type": [
        "string",
        "null"
      ]
    },
    "value": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0
        },
        {
          "type": "null"
        }
      ]
    },
    "budgetVendor": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0,
          "maximum": 999999999999.99
        },
        {
          "type": "null"
        }
      ]
    },
    "budgetClaims": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0,
          "maximum": 999999999999.99
        },
        {
          "type": "null"
        }
      ]
    },
    "budgetHours": {
      "anyOf": [
        {
          "type": "number",
          "minimum": 0,
          "maximum": 99999999.99
        },
        {
          "type": "null"
        }
      ]
    }
  }
}

Documented responses

  • 200 — OK
  • 400 — The body is not valid; `error` says why
  • 401 — No valid API key
  • 403 — The key's role lacks the permission, or the module is off
  • 404 — Not found in this company

DELETE /api/projects/{id}

Delete a project

Needs the projects.write permission on the API key's role.

Path parameters

  • id — required path parameter

No request-body schema is supplied for this operation in the registry.

Documented responses

  • 200 — OK
  • 400 — The body is not valid; `error` says why
  • 401 — No valid API key
  • 403 — The key's role lacks the permission, or the module is off
  • 404 — Not found in this company

Other policy and state errors may also apply. See API key permissions and limits and the complete OpenAPI document.